import java.awt.*;
import java.awt.event.*;


public class DrawBox extends Canvas
{
private ActionListener actionListener;
static Color bg;

public DrawBox()
	{
	super();
	bg = Color.blue;
	enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}

public DrawBox(Color background)
	{
	super();
	bg = background;
	enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}

public void drawBorder(Graphics g)
	{
	Dimension d = getSize();
	g.setColor(Color.black);
	g.drawRect(0,0,d.width-1,d.height-1);
	}

public void paint(Graphics g)
	{
	clear(g);
	drawBorder(g);
	}

public void clear(Graphics g)
	{
	Dimension d = getSize();
	g.setColor(bg);
	g.fillRect(0,0,d.width,d.height);
	}

public Dimension getPreferredSize()
	{
	return new Dimension(50,50);
	}

public Dimension getMinimumSize()
	{
	return new Dimension(50,50);
	}

public void addActionListener(ActionListener listener)
	{
	actionListener = AWTEventMulticaster.add(actionListener, listener);
	enableEvents(AWTEvent.MOUSE_EVENT_MASK);
	}

public void removeActionListener(ActionListener listener)
	{
	actionListener = AWTEventMulticaster.remove(actionListener, listener);
	}

public void processMouseEvent(MouseEvent e)
	{
	switch(e.getID())
		{
		case MouseEvent.MOUSE_PRESSED:
		repaint(); 
		break;

		case MouseEvent.MOUSE_RELEASED:
		if(actionListener != null)
			{
			repaint();
			actionListener.actionPerformed(new ActionEvent(this, ActionEvent.ACTION_PERFORMED, ""));
			}
			break;
		}
	super.processMouseEvent(e);
}

}
