import java.awt.*;
import java.lang.*;
import java.applet.*;
import java.math.*;

public class Turtle extends Applet implements Cloneable
{
private boolean pen = true;
public double x,y;
public int angle;

public Turtle(int xp,int yp,int theta)
	{
	this.x = (double) xp;
	this.y = (double) yp;
	this.angle = theta;
	} // end specific turtle

public synchronized Object clone()
{
Turtle t = new Turtle(0,0,this.angle);
t.pen = this.pen;
t.x = this.x;
t.y = this.y;
//t.angle = this.angle;
return t;
}

public void LeftTurn(int angle)
	{
	this.angle -= angle;
	if (this.angle<0) this.angle+=360;    // stop big angles from overflowing incrementally
	if (this.angle>360) this.angle-=360;
	} // end LeftTurn by angle

public void RightTurn(int angle)
	{
	LeftTurn(-angle);
	} // end LeftTurn by angle

public void Forward(int distance,Graphics g)
	{
	int x1,y1;

	x1 = (int)this.x;
	y1 = (int)this.y;

	this.x = this.x + Math.cos(this.angle * Math.PI/180.0) * distance;
	this.y = this.y + Math.sin(this.angle * Math.PI/180.0) * distance;

	if (pen)
		{
		g.drawLine(x1,y1,(int)this.x,(int)this.y);
		}
	} // end forward


public void BackWard(int distance,Graphics g)
	{
	Forward(-distance,g);
	} // end backward

public void PenUp()
	{
	pen = false;
	} // end PenUp

public void PenDown()
	{
	pen = true;
	} // end PenDown
} // end turtle class

